﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Clients.Hive.Administration {
  [Item("Hive Administration", "Hive Administration")]
  public class HiveAdministrationClient : Item {
    public List<SlaveGroup> SlaveGroups;
    public List<Slave> Slaves;
    public List<string> Users;

    public HiveAdministrationClient() {
      UpdateSlaveGroups();
      Users = new List<string>();
      Users.Add("Mr. White");
      Users.Add("Mr. Pink");
      Users.Add("Mr. Blue");
    }

    protected HiveAdministrationClient(HiveAdministrationClient original, Cloner cloner)
      : base(original, cloner) {
      //TODO: clone
    }
    public override IDeepCloneable Clone(HeuristicLab.Common.Cloner cloner) {
      return new HiveAdministrationClient(this, cloner);
    }

    public void UpdateSlaveGroups() {
      /*SlaveGroup sg = new SlaveGroup();
      sg.Name = "Test" + Guid.NewGuid();
      sg.Description = "TestGroupdesc";
      sg.Id = Guid.NewGuid();
      ServiceLocator.Instance.CallHiveService(service => service.AddSlaveGroup(sg));*/


      ServiceLocator.Instance.CallHiveService(service => {
        SlaveGroups = new List<SlaveGroup>(service.GetSlaveGroups());
        Slaves = new List<Slave>(service.GetSlaves());
        OnItemImageChanged();
      });
    }
  }
}
